import type { Queue } from "./queue.js";
import type { Comparator } from "@rickosborne/typical";
export declare class ArrayBinaryMinHeap<T> implements Queue<T> {
    private readonly comparator;
    private count;
    private readonly items;
    constructor(comparator: Comparator<T>);
    get length(): number;
    add(value: T): void;
    protected down(index: number): void;
    protected minChild(index: number): number;
    peek(): T | undefined;
    remove(item: T): void;
    private removeAt;
    sort(): void;
    take(): T | undefined;
    toArray(): T[];
    protected up(index: number): void;
    values(): Generator<T, void, undefined>;
    protected valuesAndIndexes(): Generator<[T, number], void, undefined>;
}
export declare const arrayBinaryMinHeap: <T>(comparator: Comparator<T>) => ArrayBinaryMinHeap<T>;
export declare const arrayBinaryMaxHeap: <T>(comparator: Comparator<T>) => ArrayBinaryMinHeap<T>;
