import type { Queue } from "./queue.js";
import type { Comparator } from "@rickosborne/typical";
export declare class PriorityArray<T> implements Queue<T> {
    private readonly comparator;
    private readonly items;
    constructor(comparator: Comparator<T>);
    get [Symbol.toStringTag](): string;
    get length(): number;
    add(value: T): void;
    peek(): T | undefined;
    remove(item: T): void;
    take(): T | undefined;
    toArray(): T[];
    values(): Generator<T, void, undefined>;
}
