import type { Queue } from "./queue.js";
import type { Comparator } from "@rickosborne/typical";
export declare class PriorityLinkedList<T> implements Queue<T> {
    private readonly comparator;
    private readonly list;
    constructor(comparator: Comparator<T>);
    add(item: T): void;
    get length(): number;
    peek(): T | undefined;
    remove(item: T): void;
    take(): T | undefined;
    toArray(): T[];
    values(): Generator<T, void, undefined>;
}
